Attribute VB_Name = "artnet"
Option Explicit

' art-net 1.4 - simple, simple art-net node driver for VB6
' GPL GNU software by hippy (rowanmac@optusnet.com.au)

' modified by raphael willkens (Mr FreeStyler) for simplicity
' modified for DMXSimple16 by hippy

' THIS IS A STRIPPED DOWN VERSION

 Const OemUnknown = &HFF    ' Reserved for Unknown
 Const DefaultPort = &H1936 ' socket udp port
 Const ProtocolVersion = 14

'' OpCodes (byte-swapped)
 Const OpPoll = &H2000             'Poll */
 Const OpPollReply = &H2100        'ArtPollReply */
 Const OpPollFpReply = &H2200      'Reply from Four-Play */
 Const OpOutput = &H5000           'Output */
 Const OpAddress = &H6000      'Program Node Settings */
 Const OpInput = &H7000            'Setup DMX input enables */

 Const MaxNumPorts = 1 '4
 Const MaxExNumPorts = 32
 Const ShortNameLength = 18
 Const LongNameLength = 64
 Const PortNameLength = 32
 Const MaxDataLength = 511 ' 512-1

 Const StyleNode = 0    ' Responder is a Node (DMX <-> Ethernet Device)
 Const StyleServer = 1  ' Lighting console or similar

 Const PORT_TYPE_DMX_OUTPUT = 0 Or 128
 Const PORT_TYPE_DMX_INPUT = 0 Or 256

Type T_Addr
     IP(1 To 4) As Byte ' IP address
     Port As Integer ' UDP port BYTE-SWAPPED MANUALLY
End Type

Type T_ArtPoll
  ID(0 To 7) As Byte ' protocol ID = "Art-Net"
  OpCode As Integer ' == OpPoll
  VersionH As Byte ' 0
  Version As Byte ' protocol version, set to ProtocolVersion
  TalkToMe As Byte  ' bit 0 = not used
                    '   Prev def was bit 0 = 0 if reply is broadcast
                    '        bit 0 = 1 if reply is to server IP
                    ' All replies are noe broadcast as this feature caused too many
                    ' tech support calls
                    ' bit 1 = 0 then Node only replies when polled
                    ' bit 1 = 1 then Node sends reply when it needs to
 pad As Byte
End Type

Type T_ArtPollReply
    ID(0 To 7) As Byte     ' protocol ID = "Art-Net"
    OpCode As Integer      ' == OpPollReply
    Addr As T_Addr      ' 0 if not yet configured
    VersionInfoH As Byte   ' The node's current FIRMWARE VERS hi
    VersionInfo As Byte    ' The node's current FIRMWARE VERS lo
    SubSwitchH As Byte     ' 0 - not used yet
    subswitch As Byte      ' from switch on front panel (0-15)
    Oem As Integer
    UbeaVersion As Byte   ' Firmware version of UBEA
    Status  As Byte
    EstaMan  As Integer        ' Reserved for ESTA manufacturer id lo, zero for now
    ShortName As String * ShortNameLength ' short name defaults to IP
    LongName As String * LongNameLength ' long name
    NodeReport As String * LongNameLength
    NumPortsH  As Byte
    NumPorts  As Byte               ' 4 If num i/p ports is dif to output ports, return biggest
    PortTypes(1 To MaxNumPorts) As Byte
    GoodInput(1 To MaxNumPorts) As Byte
    GoodOutput(1 To MaxNumPorts)
    Swin(1 To MaxNumPorts)  As Byte
    Swout(1 To MaxNumPorts)   As Byte
    SwVideo    As Byte
    SwMacro  As Byte
    SwRemote   As Byte
    Spare1    As Byte             ' Spare, currently zero
    Spare2    As Byte             ' Spare, currently zero
    Spare3    As Byte              ' Spare, currently zero
    Style     As Byte               ' Set to Style code to describe type of equipment
    Mac(1 To 6) As Byte               ' Mac Address, zero if info not available
    Filler(1 To 32)   As Byte              ' Filler bytes, currently zero.
End Type

Type T_ArtDmx
    ID(0 To 7) As Byte         ' protocol ID = "Art-Net"
    OpCode As Integer     ' == OpOutput
    VersionH As Byte      ' 0
    Version  As Byte      ' protocol version, set to ProtocolVersion
    Sequence As Byte      ' 0 if not used, else 1-255 incrementing sequence number
    Physical As Byte      ' The physical i/p 0-3. For Debug only
    Universe  As Integer  ' hi nib = subnet, lo nib = wheel position
    Length As Integer     ' BYTE-SWAPPED MANUALLY
    Data(MaxDataLength) As Byte
End Type


Type T_ArtHeader
  ID(0 To 7) As Byte ' protocol ID = "Art-Net"
  OpCode As Integer '
  pad(8) As Byte
  
End Type


Private Declare Sub CopyMemory Lib "KERNEL32" Alias "RtlMoveMemory" (lpvDest As Any, lpvSrc As Any, ByVal dwSize&)
Private Declare Sub CopyString Lib "KERNEL32" Alias "RtlMoveMemory" (lpvDest As Any, ByVal strSrc As String, ByVal dwSize&)

 Const T_NODE = 0
 Const T_SERVER = 1
 Dim LocalAddr As T_Addr ' Local address info
 Dim ArtPoll As T_ArtPoll ' art poll packet
 Dim ArtPollReply As T_ArtPollReply ' art poll reply
 Dim ArtDMX As T_ArtDmx ' art dmx packet
 Dim ArtHeader As T_ArtHeader ' packet header
 Dim PacketsRecieved As Long ' total art-net packets recieved

Public ArtUnivOUT As Long ' universe to send
Public ArtUnivIN As Long ' universe to recieve
Public ArtEnabled As Boolean ' enable art-net tx/rx
Dim artout(512) As Byte

' mod by hippy rowanmac@optusnet.com.au 19/01/05 - added for art-net support
' place a Winsock object called ArtSocket on the main form
' place a timer objerct called ArtTimer on the main form

Public Sub ArtNet_DataArrival()
    ' called by the _DataArrival event on the ArtSocket winsock object on the main form
     Dim buf As String
     frmMain.ARTSocket.GetData buf ' get the packet
     'artnet.Recieve_Packet (buf) ' pass the packet to the processor
End Sub

Public Sub ArtNet_SendDMX()
' call this from a _Timer event on main form
' send a DMX update
Dim a As Long
 For a = 0 To 511
    artout(a) = dmxdata(a + 1)
 Next a
' send the dmxdata array to art-net universe 0 subnet 0
 ' Call artnet.Send_DMX(0, 0, artout)  ' need to fix this ************************************************
End Sub

Public Sub ArtNet_Init()
    If artnet.ArtNet_InitNode = 1 Then ArtEnabled = True
    frmMain.DMXtimer.Enabled = ArtEnabled
End Sub


Public Function SetBit(InByte As Byte, Bit As Byte) As Byte
SetBit = InByte Or (2 ^ Bit)  'Set het n'de Bit
End Function
Public Function ClearBit(InByte As Byte, Bit As Byte) As Byte
ClearBit = InByte And Not (2 ^ Bit) 'Clear het n'de Bit
End Function
Public Function IsBitSet(InByte As Byte, Bit As Byte) As Boolean
IsBitSet = ((InByte And (2 ^ Bit)) > 0)
End Function
Public Function ToggleBit(InByte As Byte, Bit As Byte) As Byte
ToggleBit = InByte Xor (2 ^ Bit)
End Function
Function End16(ByVal iNum As Integer) As Integer
Dim iRes As Variant
iRes = (iNum And &HFF) * 2 ^ 8
iRes = iRes Or (iNum And &HFF00) / 256
End16 = iRes - IIf(iRes > 32767, 65536, 0)
End Function



Public Function ArtNet_InitNode() As Long
Dim intError As Integer
ArtNet_InitNode = -1

'LocalAddr.IP(1) = 0
'LocalAddr.IP(2) = 0
'LocalAddr.IP(3) = 0
'LocalAddr.IP(4) = 0
'LocalAddr.Port = artnet.DefaultPort

' initialize Art-Net socket
On Error GoTo doh

With frmMain.ARTSocket '  **************************
 .Bind &H1936
 .RemotePort = &H1936
End With
 
ArtNet_InitNode = 1
'DebugLog ("Art-Net Node Started...")
Exit Function
 
doh:
ArtNet_InitNode = 0
' DebugLog ("Art-Net Error!")
End Function      'artnet_initnode


Public Sub ArtNet_NodeClose()
'DebugLog ("Art-Net Finished")
End Sub
Public Function ArtNet_Send_DMX(univ As Byte, subnet As Byte, dmxdata() As Byte) As Long

Dim sndDmx As artnet.T_ArtDmx ' packet to send
Dim byBuffer(0 To Len(sndDmx)) As Byte
Dim buf As String

On Error GoTo ErrorDoh

' fill the packet
With sndDmx
.ID(0) = Asc("A")  ' header
.ID(1) = Asc("r")
.ID(2) = Asc("t")
.ID(3) = Asc("-")
.ID(4) = Asc("N")
.ID(5) = Asc("e")
.ID(6) = Asc("t")
.ID(7) = &H0
.OpCode = OpOutput         ' Art Output packet
      
.Version = artnet.ProtocolVersion
.VersionH = 0  ' not used
.Sequence = 0  ' not used
.Physical = 0  ' not used
.Universe = univ ' does not have subnet yet
.Length = End16(512) ' data length (manual byteswap)
CopyMemory .Data(0), dmxdata(0), 511   ' copy the dmx to send into the packet
End With ' snddmx

CopyMemory byBuffer(0), sndDmx, Len(sndDmx) ' copy the packet into the buffer
buf = Left$(StrConv(byBuffer, 64), Len(sndDmx))  ' make the string buffer

frmMain.ARTSocket.SendData (buf) ' send the buffer

ArtNet_Send_DMX = 1 ' success
Exit Function

ErrorDoh:
ArtNet_Send_DMX = 0 ' fail
End Function




Public Sub ArtNet_Recieve_Packet(buf As String)
Dim a As Long
Dim tmp As String
 tmp = ""
 Call CopyString(ArtHeader, buf, Len(ArtHeader))
 For a = 0 To 7
  tmp = tmp & Chr(ArtHeader.ID(a))
 Next a
 If (tmp) = ("Art-Net" & Chr(0)) Then
  'PacketsRecieved = PacketsReceived + 1 ' packet recieved
 Else
  Exit Sub  ' not an art-net packet!
 End If

 'ArtNetDetected = True

 If ArtHeader.OpCode = OpPoll Then
'  Call DebugLog("ArtPoll Recieved")
  CopyString ArtPoll, buf, Len(ArtPoll)
  Call ArtNet_Poll_Reply ' reply to the artpoll packet we just recieved
  Exit Sub ' finished processing this packet
 End If ' ArtPoll Packet
 
 If ArtHeader.OpCode = OpOutput Then
  CopyString ArtDMX, buf, Len(ArtDMX)

 If ArtUnivIN >= 0 Then
  If ArtDMX.Universe = ArtUnivIN Then ' if is our universe
   For a = 0 To 511
    dmxdata(a + 1) = ArtDMX.Data(a)  ' recieve art-net - send dmx to SimpleDMX
   Next a
   'FrameCountIN = FrameCountIN + 1
  End If '
 End If
  
 Exit Sub ' finished processing this packet
 End If ' dmx packet
 
End Sub ' recieve packet

Public Sub ArtNet_Poll_Reply()
Dim buf As String
Dim byBuffer(Len(ArtPollReply)) As Byte

' prepare the response
Call ArtNet_ArtPollReply_Init

' copy packet structure to buffer
CopyMemory byBuffer(0), ArtPollReply, Len(ArtPollReply)
buf = Left$(StrConv(byBuffer, 64), Len(ArtPollReply))

' send the buffer
frmMain.ARTSocket.SendData (buf)

'Call DebugLog("Sent Reply")

End Sub


' Prepare ArtNet Poll Reply Packet
Private Sub ArtNet_ArtPollReply_Init()
Dim a As Long

' Header
ArtPollReply.ID(0) = Asc("A")
ArtPollReply.ID(1) = Asc("r")
ArtPollReply.ID(2) = Asc("t")
ArtPollReply.ID(3) = Asc("-")
ArtPollReply.ID(4) = Asc("N")
ArtPollReply.ID(5) = Asc("e")
ArtPollReply.ID(6) = Asc("t")
ArtPollReply.ID(7) = &H0
ArtPollReply.OpCode = OpPollReply      ' Reply packet to ArtPoll


ArtPollReply.Addr = LocalAddr ' our address
ArtPollReply.VersionInfoH = 0
ArtPollReply.VersionInfo = artnet.ProtocolVersion

ArtPollReply.SubSwitchH = 0
ArtPollReply.subswitch = 0

ArtPollReply.Oem = End16(artnet.OemUnknown) ' OEM
ArtPollReply.UbeaVersion = 0
ArtPollReply.Status = 0
ArtPollReply.EstaMan = 0
ArtPollReply.ShortName = App.ProductName
ArtPollReply.LongName = App.ProductName & " [by Glenn Meader 2004 glenn@chromakinetics.com]"
ArtPollReply.NodeReport = "ArtNet By Hippy (rowanmac@optusnet.com.au)"

ArtPollReply.NumPortsH = 0
ArtPollReply.NumPorts = 1

ArtPollReply.PortTypes(1) = SetBit(0, 7) ' Set as output

ArtPollReply.GoodInput(1) = 0 'SetBit(0, 7) ' good, recieveing :)

ArtPollReply.GoodOutput(1) = SetBit(0, 7) ' good, transmitting

ArtPollReply.Swin(1) = ArtUnivIN

' set output universes
ArtPollReply.Swout(1) = 0

ArtPollReply.SwVideo = 0
ArtPollReply.SwMacro = 0
ArtPollReply.SwRemote = 0

ArtPollReply.Style = StyleServer

ArtPollReply.Spare1 = 0
ArtPollReply.Spare2 = 0
ArtPollReply.Spare3 = 0

ArtPollReply.Mac(1) = 0
'ArtPollReply.Mac(2) = 0
'ArtPollReply.Mac(3) = 0
'ArtPollReply.Mac(4) = 0
'ArtPollReply.Mac(5) = 0
'ArtPollReply.Mac(6) = 0

For a = 1 To 32
ArtPollReply.Filler(a) = 0
Next a
End Sub








