# StageConsole.nsi installation script
# Automatically generated by VB6Converter by David Nuttall
# VB6Converter was compiled on 21/09/06
#

Name "StageConsole 1.6.0-Setup"
OutFile "StageConsole 1.6.0-Setup.exe"
SetCompress auto
SetCompressor /SOLID /FINAL Lzma
WindowIcon on
AutoCloseWindow false
SetDatablockOptimize on
CRCCheck on
InstProgressFlags smooth
SetDateSave on
AllowSkipFiles on
SetOverwrite IfNewer
InstallDir "$ProgramFiles\StageConsole"

!include Library.nsh

Page Directory
Page Components
Page InstFiles

Var ALREADY_INSTALLED
Var Version

Section "StageConsole 1.6.0"
	SectionIn 1 RO
	;LogSet on	# Needs special build of NSIS to actually work.
	# Change the registry structure to reflect the directory structure you are using.
	ReadRegDWord $Version HKLM "Software\StageConsole 1.6.0" Version
	IfErrors new_installation
	StrCpy $ALREADY_INSTALLED 1
	new_installation:

	SetOutPath "$InstDir"
	File /a "Support\default.shw"
	SetOutPath "$InstDir"
	File /a "Support\demo.shw"
	SetOutPath "$SysDir"
	File /a "Support\hh.exe"
	!insertmacro InstallLib REGDLL $ALREADY_INSTALLED REBOOT_PROTECTED \
		"Support\itircl.dll" "$SysDir\itircl.dll" "$SysDir"
	!insertmacro InstallLib REGDLL $ALREADY_INSTALLED REBOOT_PROTECTED \
		"Support\itss.dll" "$SysDir\itss.dll" "$SysDir"
	!insertmacro InstallLib REGDLL $ALREADY_INSTALLED REBOOT_PROTECTED \
		"Support\hhctrl.ocx" "$SysDir\hhctrl.ocx" "$SysDir"
	SetOutPath "$InstDir"
	File /a "Support\StageConsole.chm"
	!insertmacro InstallLib REGDLL $ALREADY_INSTALLED REBOOT_PROTECTED \
		"Support\MSWINSCK.OCX" "$SysDir\MSWINSCK.OCX" "$SysDir"
	!insertmacro InstallLib REGDLL $ALREADY_INSTALLED REBOOT_PROTECTED \
		"Support\MSCOMM32.OCX" "$SysDir\MSCOMM32.OCX" "$SysDir"
	!insertmacro InstallLib REGDLL $ALREADY_INSTALLED REBOOT_PROTECTED \
		"Support\msflxgrd.ocx" "$SysDir\msflxgrd.ocx" "$SysDir"
	!insertmacro InstallLib REGDLL $ALREADY_INSTALLED REBOOT_PROTECTED \
		"Support\mscomctl.ocx" "$SysDir\mscomctl.ocx" "$SysDir"
	!insertmacro InstallLib REGDLL $ALREADY_INSTALLED REBOOT_PROTECTED \
		"Support\mscomct2.ocx" "$SysDir\mscomct2.ocx" "$SysDir"
	!insertmacro InstallLib REGDLL $ALREADY_INSTALLED REBOOT_PROTECTED \
		"Support\comdlg32.ocx" "$SysDir\comdlg32.ocx" "$SysDir"
	!insertmacro InstallLib DLL $ALREADY_INSTALLED REBOOT_PROTECTED \
		"Support\OpenDmxUsbCom.dll" "$SysDir\OpenDmxUsbCom.dll" "$SysDir"
	!insertmacro InstallLib DLL $ALREADY_INSTALLED REBOOT_PROTECTED \
		"Support\FTD2XX.dll" "$SysDir\FTD2XX.dll" "$SysDir"
	SetOutPath "$InstDir"
	File /a "Support\StageConsole.exe"

	# Put shortcuts in the start menu
	CreateDirectory "$SMPrograms"
	CreateShortCut "$SMPrograms\StageConsole.lnk" "$InstDir\StageConsole.exe"
	WriteRegDWord HKLM "Software\StageConsole" Version 1
	WriteUninstaller "$InstDir\uninstaller.exe"
	# Add uninstaller information to registry.
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\StageConsole" "DisplayName" "StageConsole"
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\StageConsole" "UninstallString" '"$InstDir\uninstaller.exe"'
	WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\StageConsole" "NoModify" 1
	WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\StageConsole" "NoRepair" 1
SectionEnd

Section Uninstall
	Delete /RebootOk "$SMPrograms\StageConsole.lnk"
	UnRegDLL "$InstDir\StageConsole.exe"
	Delete /RebootOk "$InstDir\StageConsole.exe"
	!insertmacro UnInstallLib REGDLL SHARED REBOOT_PROTECTED "$SysDir\FTD2XX.dll"
	!insertmacro UnInstallLib REGDLL SHARED REBOOT_PROTECTED "$SysDir\OpenDmxUsbCom.dll"
	Delete /RebootOk "$InstDir\StageConsole.chm"
	!insertmacro UnInstallLib REGDLL SHARED REBOOT_PROTECTED "$SysDir\hhctrl.ocx"
	!insertmacro UnInstallLib REGDLL SHARED REBOOT_PROTECTED "$SysDir\itss.dll"
	!insertmacro UnInstallLib REGDLL SHARED REBOOT_PROTECTED "$SysDir\itircl.dll"
	UnRegDLL "$SysDir\hh.exe"
	Delete /RebootOk "$SysDir\hh.exe"
	Delete /RebootOk "$InstDir\demo.shw"
	Delete /RebootOk "$InstDir\default.shw"
	DeleteRegKey HKLM "Software\StageConsole"
	SetOutPath "\"	;Change to root directory to allow the next step to succeed.
	RmDir /RebootOk "$INSTDIR"
SectionEnd

Section "-Install VB6 runtimes"
	;Add code here that sets $ALREADY_INSTALLED to a non-zero value if"
	;the application is already installed. For example:

	IfFileExists "C:\Documents and Settings\user\My Documents\Projects\DMXconsole\Package\StageConsole 1.5.0.nsi.exe" 0 new_installation2
	StrCpy $ALREADY_INSTALLED 1
	new_installation2:

	!insertmacro InstallLib REGDLL $ALREADY_INSTALLED REBOOT_NOTPROTECTED \
		"Support\msvbvm60.dll" "$SYSDIR\msvbvm60.dll" "$SYSDIR"
	!insertmacro InstallLib REGDLL $ALREADY_INSTALLED REBOOT_PROTECTED \
		"Support\oleaut32.dll" "$SYSDIR\oleaut32.dll" "$SYSDIR"
	!insertmacro InstallLib REGDLL $ALREADY_INSTALLED REBOOT_PROTECTED \
		"Support\olepro32.dll" "$SYSDIR\olepro32.dll" "$SYSDIR"
	!insertmacro InstallLib REGDLL $ALREADY_INSTALLED REBOOT_PROTECTED \
		"Support\comcat.dll"   "$SYSDIR\comcat.dll"   "$SYSDIR"
	!insertmacro InstallLib DLL    $ALREADY_INSTALLED REBOOT_PROTECTED \
		"Support\asycfilt.dll" "$SYSDIR\asycfilt.dll" "$SYSDIR"
	!insertmacro InstallLib TLB    $ALREADY_INSTALLED REBOOT_PROTECTED \
		"Support\stdole2.tlb"  "$SYSDIR\stdole2.tlb"  "$SYSDIR"
SectionEnd

Section "-un.Uninstall VB6 runtimes"
	!insertmacro UnInstallLib REGDLL SHARED NOREMOVE "$SYSDIR\msvbvm60.dll"
	!insertmacro UnInstallLib REGDLL SHARED NOREMOVE "$SYSDIR\oleaut32.dll"
	!insertmacro UnInstallLib REGDLL SHARED NOREMOVE "$SYSDIR\olepro32.dll"
	!insertmacro UnInstallLib REGDLL SHARED NOREMOVE "$SYSDIR\comcat.dll"
	!insertmacro UnInstallLib DLL    SHARED NOREMOVE "$SYSDIR\asycfilt.dll"
	!insertmacro UnInstallLib TLB    SHARED NOREMOVE "$SYSDIR\stdole2.tlb"
SectionEnd
