Attribute VB_Name = "USBDMXPro"
Option Explicit
Private Declare Sub Sleep Lib "KERNEL32" (ByVal dwMilliseconds As Long)
Dim Firmware_VersionL As Byte
Dim Firmware_VersionH As Byte  '
Dim serial As String
Dim BreakTime As Byte  ' 9..127 in 10.67us units
Dim MarkAfterBreak As Byte  ' 1..127 in 10.67us units
Dim FrameRate As Byte  ' frames sent per second, 1..40
Const MaxPorts = 16 ' max number of serial ports to handle

Dim packetbuffer As String
' eg after SearchPorts, if com_ports(4) = true this com port 4 actually exists
Dim Com_Ports(1 To MaxPorts) As Boolean
Dim Widgets_Found(1 To MaxPorts) As Boolean
' misc packet constants - don't work as cost for some reason
'Const SOM = &H7E ' Start Of Message Marker
'Const EOM = &HE7 ' End Of Message Marker
Public Const GET_WIDGET_CFG_REPLY = 3 ' returned config
Public Const DMX_INPUT = 5  ' auto sent by widget upon arrival of a dmx packet
Dim SOM As String
Dim EOM As String


Public Sub initPro()
' initialize serial port connected to Enttec USB DMX Pro widget
Dim msg As String
Dim result As Integer
    
    
    On Error Resume Next
    If frmMain.MSComm1.PortOpen = False Then
        frmMain.MSComm1.CommPort = PortNumber
        frmMain.MSComm1.PortOpen = True
    End If
    If frmMain.MSComm1.PortOpen = False Then
       MsgBox "Failed to open USB DMX Pro on comm port: " & Str(PortNumber) & " - Check Settings, Device"
       Exit Sub
    Else
        'Call Send_CFG_Request_Packet ' see if a pro responds..
        'Sleep (100)
        'if we recieve a cfg reply then we know we have a pro widget
        'If frmMain.MSComm1.InBufferCount > 0 Then result = Recieve_Packet(frmMain.MSComm1.Input)
                
       'start the interface sending DMX msgnumber 6 and 1 byte of data
        msg = Chr(126) & Chr(6) & Chr(1) & Chr(0) & Chr(0) & Chr(231)
        frmMain.MSComm1.Output = msg
        deviceInitialized = True
        frmOutputMonitor.Caption = "Output on Enttec USBDMX Pro port: " & PortNumber & " firmware: " & Firmware_VersionH & "." & Firmware_VersionL
         frmMain.updateLevels
   End If
End Sub

Public Sub closePro()
' close serial port connected to Enttec USB DMX Pro widget
  If deviceInitialized = True Then
      frmMain.MSComm1.PortOpen = False
  End If
End Sub

Public Sub sendDMXpro()
' send DMX data to Enttec USB DMX Pro widget
  Dim msg As String
  Dim levels As String
  Dim startcode As String
  Dim dataLen As Integer
  Dim dataLenLSB As Integer
  Dim dataLenMSB As Integer
  Dim i As Integer
  startcode = Chr(0)
  'create msg string from public dmxdata array
  levels = ""
  frmOutputMonitor.lblOut.Caption = ""
  For i = 1 To UBound(dmxdata)
    levels = levels & Chr(dmxdata(i))
    ' display levels
    'OutputMonitor.lblOut.Caption = OutputMonitor.lblOut.Caption & " " & Str(dmxdata(i))
  Next
  dataLen = Len(levels) + 1 ' for startcode, total data length should = 513
  'OutputMonitor.lblOut.Caption = Str(dataLen) & ":" '& levels
  'calculate MSB and LSB for length of DMX data
  If dataLen >= 256 Then
    dataLenLSB = dataLen - 256
    dataLenMSB = 1
    If dataLenLSB >= 256 Then
      dataLenLSB = dataLenLSB - 256
      dataLenMSB = 2
    End If
  Else
    dataLenLSB = dataLen
    dataLenMSB = 0
  End If
  ' sending DMX msgnumber 6 and dataLen bytes of data
  msg = Chr(126) & Chr(6) & Chr(dataLenLSB) & Chr(dataLenMSB) & startcode & levels & Chr(231)
  If deviceInitialized = True Then
    frmMain.MSComm1.Output = msg
  End If
  If frmOutputMonitor.mnuDeviceOutput.Checked Then
     frmOutputMonitor.lblOut.Caption = Str(dataLen) & ":" & hexStr(msg)  ' display hex message
  End If
End Sub
  
Public Function hexStr(binStr As String) As String
    'returns string of hex digits for each character in binStr
  Dim i As Integer
  Dim result As String
  For i = 1 To Len(binStr)
    result = result + Hex(Asc(Mid(binStr, i, 1))) + " "
  Next
  hexStr = result
End Function
Public Sub SearchPorts()
' try opening com ports to see if one is alive..
Dim i As Long
Dim flush As String

SOM = Chr(126)
EOM = Chr(231)
On Error Resume Next ' IN CASE OF INVALID PORTS
For i = 1 To MaxPorts
        Com_Ports(i) = False
        Widgets_Found(i) = False
        serial = ""
        frmMain.MSComm1.CommPort = i
        frmMain.MSComm1.PortOpen = True
        If frmMain.MSComm1.PortOpen = True Then
            Com_Ports(i) = True ' port exists
            flush = frmMain.MSComm1.Input
            'Call Send_CFG_Request_Packet ' see if a pro responds..
            Call Send_Serial_Request_Packet ' see if a pro responds.
            Sleep (50)
             'if we recieve a reply then we know we have a pro widget (hope)
            If frmMain.MSComm1.InBufferCount > 0 Then
               If Recieve_Packet(frmMain.MSComm1.Input) = 10 Then
                If Len(serial) > 2 Then
                'If Asc(Firmware_VersionH) >= 1 Then
                   Widgets_Found(i) = True ' found a widget
                End If
               End If
            End If
            frmMain.MSComm1.PortOpen = False ' close the port
        End If
        If Widgets_Found(i) = True Then
           'devList.AddItem "Pro Widget - Com:  " & i & " : " & Trim(Str(Asc(Firmware_VersionH))) & "." & Trim(Str(Asc(Firmware_VersionL)))
        frmDevice.devList.AddItem "Pro Widget - Com:  " & i & " : " & serial
        frmDevice.devList.ItemData(frmDevice.devList.NewIndex) = i


Else
          If Com_Ports(i) Then frmDevice.devList.AddItem "Com: " & i
        End If
Next i
End Sub


Public Sub Send_CFG_Request_Packet()
' send DMX data to Enttec USB DMX Pro widget
  Dim msg As String
  ' sending DMX msgnumber 3
  msg = Chr(126) & Chr(3) & Chr(2) & Chr(0) & Chr(0) & Chr(0) & Chr(231)
  frmMain.MSComm1.Output = msg
End Sub
Public Sub Send_Serial_Request_Packet()
' send DMX data to Enttec USB DMX Pro widget
  Dim msg As String
  ' sending DMX msgnumber 10
  msg = Chr(126) & Chr(10) & Chr(1) & Chr(0) & Chr(0) & Chr(231)
  frmMain.MSComm1.Output = msg
End Sub

Public Function Recieve_Packet(buf As String) As Long
' input: string containing data sent from the widget (buf)
' output: if recieved dmx, copy it to DMX_IN,
'         if recieved config setting, copy them to GET_CFG
'         if recieved flash firmware page ack, send next page or fail.
Dim tmpstr As String
Dim tmpsom As Long
Dim tmpeom As Long
Firmware_VersionL = ""
Firmware_VersionH = ""
SOM = Chr(126)
EOM = Chr(231)
frmDevice.lblinfo.Caption = hexStr(buf)
On Error GoTo rxerror

Recieve_Packet = 0 ' no packet recieved..

'DMX_ERROR (ERR_OK)

For tmpsom = 1 To Len(buf)
 If Mid(buf, tmpsom, 1) = SOM Then
   buf = Mid(buf, tmpsom)
  GoTo FoundSOM
 End If
Next tmpsom
FoundSOM:
 
For tmpeom = tmpsom To Len(buf)
 If Mid(buf, tmpeom, 1) = EOM Then
   buf = Left(buf, tmpeom)
  GoTo FoundEOM
 End If
Next tmpeom
FoundEOM:
  
' TESTING !!

 If Len(buf) < 4 Then ' invalid packet size
  'DMX_ERROR (ERR_PACKET_TOO_SHORT)
  Recieve_Packet = -1
  Exit Function
 End If

 ' read the data into a header structure..
 'CopyString header, buf, Len(header)
 
 ' check to see if the packet delimiter is correct
 If Left(buf, 1) <> SOM Then ' if is not Start Of Message byte
  MsgBox "Bad data received from widget, not start of message: " & hexStr(buf)
'  DMX_ERROR (ERR_NOT_VALID_PACKET)
  Recieve_Packet = -2
  Exit Function ' fail
 End If

 ' check for silly values to help in error checking
 If Len(buf) > 600 Then ' check this!!!
  'DMX_ERROR (ERR_DATA_LENGTH_INVALID)
  Recieve_Packet = -3
  Exit Function ' fail
 End If
  
 Recieve_Packet = val(Asc(Mid(buf, 2, 1))) 'header.Label
   ' determine what kind of packet we recieved
 Select Case Recieve_Packet
    Case 3 ' recieved configuration data from the widget
          Firmware_VersionL = Mid(buf, 5, 1)
          Firmware_VersionH = Mid(buf, 6, 1)
          BreakTime = Mid(buf, 7, 1) ' 9..127 in 10.67us units
          MarkAfterBreak = Mid(buf, 8, 1) ' 1..127 in 10.67us units
          FrameRate = Mid(buf, 9, 1) ' frames sent per second, 1..40
          frmDevice.lblResult = "Firmware: " & Trim(Str(Asc(Firmware_VersionH))) & "." & Trim(Str(Asc(Firmware_VersionL)))
    Case 5 ' recieved a dmx packet from the widget
      ' copy the data from the buffer into the DMX_IN structure
      'CopyString DMX_IN, buf, (Len(buf) - 1)
    Case 10 ' got  serial number
       serial = Right("0" & Trim(hexStr(Mid(buf, 8, 1))), 2) & Right("0" & Trim(hexStr(Mid(buf, 7, 1))), 2) & Right("0" & Trim(hexStr(Mid(buf, 6, 1))), 2) & Right("0" & Trim(hexStr(Mid(buf, 5, 1))), 2)
       frmDevice.lblResult = "serial number:  " & serial
 End Select

 Exit Function ' success
' serious error has occured
rxerror:
 MsgBox Err.Description
End Function
